import { Query, QueryCache, QueryKey } from 'react-query';
export interface DehydratedQueryConfig {
    queryKey: QueryKey;
    cacheTime?: number;
    initialData?: unknown;
}
export interface DehydratedQuery {
    config: DehydratedQueryConfig;
    updatedAt: number;
}
export interface DehydratedState {
    queries: Array<DehydratedQuery>;
}
export declare type ShouldDehydrateFunction = <TResult, TError = unknown>(query: Query<TResult, TError>) => boolean;
export interface DehydrateConfig {
    shouldDehydrate?: ShouldDehydrateFunction;
}
export declare function dehydrate(queryCache: QueryCache, dehydrateConfig?: DehydrateConfig): DehydratedState;
export declare function hydrate<TResult>(queryCache: QueryCache, dehydratedState: unknown): void;
